]> git.proxmox.com Git - rustc.git/blob - src/ci/run.sh
Update upstream source from tag 'upstream/1.63.0+dfsg1'
[rustc.git] / src / ci / run.sh
1 #!/usr/bin/env bash
2
3 set -e
4
5 if [ -n "$CI_JOB_NAME" ]; then
6 echo "[CI_JOB_NAME=$CI_JOB_NAME]"
7 fi
8
9 if [ "$NO_CHANGE_USER" = "" ]; then
10 if [ "$LOCAL_USER_ID" != "" ]; then
11 useradd --shell /bin/bash -u $LOCAL_USER_ID -o -c "" -m user
12 export HOME=/home/user
13 unset LOCAL_USER_ID
14 exec su --preserve-environment -c "env PATH=$PATH \"$0\"" user
15 fi
16 fi
17
18 # only enable core dump on Linux
19 if [ -f /proc/sys/kernel/core_pattern ]; then
20 ulimit -c unlimited
21 fi
22
23 # There was a bad interaction between "old" 32-bit binaries on current 64-bit
24 # kernels with selinux enabled, where ASLR mmap would sometimes choose a low
25 # address and then block it for being below `vm.mmap_min_addr` -> `EACCES`.
26 # This is probably a kernel bug, but setting `ulimit -Hs` works around it.
27 # See also `dist-i686-linux` where this setting is enabled.
28 if [ "$SET_HARD_RLIMIT_STACK" = "1" ]; then
29 rlimit_stack=$(ulimit -Ss)
30 if [ "$rlimit_stack" != "" ]; then
31 ulimit -Hs "$rlimit_stack"
32 fi
33 fi
34
35 ci_dir=`cd $(dirname $0) && pwd`
36 source "$ci_dir/shared.sh"
37
38 if command -v python > /dev/null; then
39 PYTHON="python"
40 elif command -v python3 > /dev/null; then
41 PYTHON="python3"
42 else
43 PYTHON="python2"
44 fi
45
46 if ! isCI || isCiBranch auto || isCiBranch beta || isCiBranch try; then
47 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set build.print-step-timings --enable-verbose-tests"
48 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set build.metrics"
49 fi
50
51 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-sccache"
52 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-manage-submodules"
53 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-locked-deps"
54 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-cargo-native-static"
55 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.codegen-units-std=1"
56
57 # Only produce xz tarballs on CI. gz tarballs will be generated by the release
58 # process by recompressing the existing xz ones. This decreases the storage
59 # space required for CI artifacts.
60 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --dist-compression-formats=xz"
61
62 if [ "$DIST_SRC" = "" ]; then
63 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-dist-src"
64 fi
65
66 # Always set the release channel for bootstrap; this is normally not important (i.e., only dist
67 # builds would seem to matter) but in practice bootstrap wants to know whether we're targeting
68 # master, beta, or stable with a build to determine whether to run some checks (notably toolstate).
69 export RUST_RELEASE_CHANNEL=$(releaseChannel)
70 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --release-channel=$RUST_RELEASE_CHANNEL"
71
72 if [ "$DEPLOY$DEPLOY_ALT" = "1" ]; then
73 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-static-stdcpp"
74 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.remap-debuginfo"
75 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --debuginfo-level-std=1"
76
77 if [ "$NO_LLVM_ASSERTIONS" = "1" ]; then
78 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-llvm-assertions"
79 elif [ "$DEPLOY_ALT" != "" ]; then
80 if [ "$NO_PARALLEL_COMPILER" = "" ]; then
81 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.parallel-compiler"
82 fi
83 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
84 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
85 fi
86 else
87 # We almost always want debug assertions enabled, but sometimes this takes too
88 # long for too little benefit, so we just turn them off.
89 if [ "$NO_DEBUG_ASSERTIONS" = "" ]; then
90 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-debug-assertions"
91 fi
92
93 # Same for overflow checks
94 if [ "$NO_OVERFLOW_CHECKS" = "" ]; then
95 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-overflow-checks"
96 fi
97
98 # In general we always want to run tests with LLVM assertions enabled, but not
99 # all platforms currently support that, so we have an option to disable.
100 if [ "$NO_LLVM_ASSERTIONS" = "" ]; then
101 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
102 fi
103
104 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
105 fi
106
107 if [ "$RUST_RELEASE_CHANNEL" = "nightly" ] || [ "$DIST_REQUIRE_ALL_TOOLS" = "" ]; then
108 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-missing-tools"
109 fi
110
111 export COMPILETEST_NEEDS_ALL_LLVM_COMPONENTS=1
112
113 # Print the date from the local machine and the date from an external source to
114 # check for clock drifts. An HTTP URL is used instead of HTTPS since on Azure
115 # Pipelines it happened that the certificates were marked as expired.
116 datecheck() {
117 echo "== clock drift check =="
118 echo -n " local time: "
119 date
120 echo -n " network time: "
121 curl -fs --head http://ci-caches.rust-lang.org | grep ^Date: \
122 | sed 's/Date: //g' || true
123 echo "== end clock drift check =="
124 }
125 datecheck
126 trap datecheck EXIT
127
128 # We've had problems in the past of shell scripts leaking fds into the sccache
129 # server (#48192) which causes Cargo to erroneously think that a build script
130 # hasn't finished yet. Try to solve that problem by starting a very long-lived
131 # sccache server at the start of the build, but no need to worry if this fails.
132 SCCACHE_IDLE_TIMEOUT=10800 sccache --start-server || true
133
134 if [ "$RUN_CHECK_WITH_PARALLEL_QUERIES" != "" ]; then
135 $SRC/configure --enable-parallel-compiler
136 CARGO_INCREMENTAL=0 $PYTHON ../x.py check
137 rm -f config.toml
138 rm -rf build
139 fi
140
141 $SRC/configure $RUST_CONFIGURE_ARGS
142
143 retry make prepare
144
145 # Display the CPU and memory information. This helps us know why the CI timing
146 # is fluctuating.
147 if isMacOS; then
148 system_profiler SPHardwareDataType || true
149 sysctl hw || true
150 ncpus=$(sysctl -n hw.ncpu)
151 else
152 cat /proc/cpuinfo || true
153 cat /proc/meminfo || true
154 ncpus=$(grep processor /proc/cpuinfo | wc -l)
155 fi
156
157 if [ ! -z "$SCRIPT" ]; then
158 sh -x -c "$SCRIPT"
159 else
160 do_make() {
161 echo "make -j $ncpus $1"
162 make -j $ncpus $1
163 local retval=$?
164 return $retval
165 }
166
167 do_make "$RUST_CHECK_TARGET"
168 fi
169
170 sccache --show-stats || true